import { Observable } from 'rxjs';
import { CloudOptions } from '../CloudOptions';
import { CloudMessageValue, ICloudClient } from './ICloudClient';
import { IConnection, CloudMessage } from '../connection/IConnection';
export declare class BaseCloudClient<T extends IConnection = IConnection> implements ICloudClient {
    protected connection: T;
    protected options: CloudOptions;
    constructor(connection: T, options: CloudOptions);
    disconnect(): Promise<void>;
    reconnect(): Promise<void>;
    protected _sendProperty(topic: string, name: string, value: CloudMessageValue, tmp?: number): Promise<void>;
    sendMessage(topic: string, message: string | ArrayBuffer): Promise<void>;
    protected observe(topic: string): Observable<CloudMessage>;
    protected unsubscribe(topic: string): Promise<void>;
}
